package beautiful05.step1;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import beautiful05.common.dao.UserDao;
import beautiful05.common.entity.User;

import com.ozacc.mail.Mail;
import com.ozacc.mail.SendMail;

public class SendMailer {

	private static final Log LOG = LogFactory.getLog(SendMailer.class);
	
	private UserDao userDao;
	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}
	
	private SendMail sendMail;
	public void setSendMail(SendMail sendMail) {
		this.sendMail = sendMail;
	}
		
	public void send(String from, String subject, String body) {
		List<Integer> userIdList = userDao.findSubscribeUserIdList();
		for (Integer userId : userIdList) {
			User user = userDao.findById(userId);
			send(user, from, subject, body);
		}
	}

	private void send(User user, String from, String subject, String body) {
		try {
			Mail mail = new Mail();
			mail.addTo(user.getMailAddress());
			mail.setFrom(from);
			mail.setSubject(subject);
			mail.setText(body);
			if (LOG.isDebugEnabled()) {
				LOG.debug("[𑗐M܂B : mail=" + mail);
			}
			sendMail.send(mail);
			if (LOG.isDebugEnabled()) {
				LOG.debug("[𑗐M܂B : mail=" + mail);
			}
		} catch (Exception ex) {
			LOG.error(ex.getMessage(), ex);
		}
	}
}
