package beautiful05.step3;

import java.util.List;

import beautiful05.common.dao.UserDao;
import beautiful05.common.entity.User;

import com.ozacc.mail.Mail;

public class UserSendMailer extends SendMailer<Integer, User> {

	private UserDao userDao;
	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}
	
	@Override
	protected List<Integer> getTargetIdList() {
		List<Integer> userIdList = userDao.findSubscribeUserIdList();
		return userIdList;
	}

	@Override
	protected User getEntity(Integer userId) {
		User user = userDao.findById(userId);
		return user;
	}

	@Override
	protected Mail makeMail(User user, String from, String subject, String body) {
		Mail mail = new Mail();
		mail.addTo(user.getMailAddress());
		mail.setFrom(from);
		mail.setSubject(subject);
		mail.setText(body);
		return mail;
	}
}
